#INCLUDE "ti82.h"
#INCLUDE "graph.h"

.ORG START_ADDR
.DB "Pong v2.0b by Linx711",0
     GRAPH_START
PADDLE   =TEXT_MEM
ballx    =TEXT_MEM+1
bally    =TEXT_MEM+2
oldballx =TEXT_MEM+3
oldbally =TEXT_MEM+4
balldirx =TEXT_MEM+5
balldiry =TEXT_MEM+6
offballx =TEXT_MEM+7
offbally =TEXT_MEM+8
moreax   =TEXT_MEM+10
moreay   =TEXT_MEM+11
morebx   =TEXT_MEM+12
moreby   =TEXT_MEM+13
morecx   =TEXT_MEM+15
morecy   =TEXT_MEM+16

start:
 ld a, $00
 ld (PADDLE), a
 ld a, $01
 ld (balldirx), a
 ld (balldiry), a
 ld a, $05
 ld (ballx), a
 ld (bally), a
 ld (oldballx), a
 ld (oldbally), a
 ld (offballx), a
 ld (offbally), a
 ld (moreax), a 
 ld (moreay), a 
 ld (morebx), a
 ld (moreby), a
 ld (morecx), a
 ld (morecy), a
drawpaddle:
 ld a, (PADDLE)
 ld b, a
 ld c, $00
points:
 ld a, (PADDLE)
 ld b, a
 CALL Point_on
 inc b
 CALL Point_on
 inc b
 CALL Point_on
 inc b
 CALL Point_on
 inc b
 CALL Point_on
 inc b
 CALL Point_on
 inc b
 CALL Point_on
 inc b
 CALL Point_on
 inc b
 CALL Point_on
 inc b
 CALL Point_on
 inc b
 CALL Point_on
 inc b
 CALL Point_on
 inc c
 ld a,c
 cp $02
 jr nz, points
getkey:
   call drawball
   halt
   halt
   ld a, %01111100
   out (1), a          
   in a, (1)    
   bit 6, a     
   jp z, quit   
   bit 2, a          
   jr z, right 
   bit 1, a           
   jr z, left
   jr getkey
right:
 ld a, (PADDLE)
 cp $54
 jr z, getkey
 ld b,a
 ld c, $01
 CALL Point_off
 inc b
 CALL Point_off
 dec c
 CALL Point_off
 dec b
 CALL Point_off
 ld a, (PADDLE)
 inc a
 inc a
 ld (PADDLE), a
 jp drawpaddle
left:
 ld a, (PADDLE)
 cp $00
 jr z, getkey
 add a, $0C
 ld b, a
 ld c, $01
 CALL Point_off
 dec b
 CALL Point_off
 dec c
 CALL Point_off
 inc b
 CALL Point_off
 ld a, (PADDLE)
 dec a
 dec a
 ld (PADDLE), a
 jp drawpaddle
drawball:
     ld a, (offballx)
     ld b, a
     ld a, (offbally)
     ld c, a
     CALL Point_off
     ld a, (offballx)
     ld b, a
     ld a, (offbally)
     ld c, a
     inc b
     CALL Point_off
     ld a, (offballx)
     ld b, a
     ld a, (offbally)
     ld c, a
     inc b
     dec c
     CALL Point_off
     ld a, (offballx)
     ld b, a
     ld a, (offbally)
     ld c, a
     dec c
     CALL Point_off
     ld a, (morecx)
     ld (offballx), a
     ld a, (morecy)
     ld (offbally), a
     ld a, (morebx)
     ld (morecx), a
     ld a, (moreby)
     ld (morecy), a
     ld a, (moreax)
     ld (morebx), a
     ld a, (moreay)
     ld (moreby), a
     ld a, (oldballx)
     ld (moreax), a
     ld a, (oldbally)
     ld (moreay), a
     ld a, (ballx)
     ld b, a
     ld a, (bally)
     ld c, a
     CALL Point_on
     ld a, (ballx)
     ld b, a
     ld a, (bally)
     ld c, a
     inc b
     CALL Point_on
     ld a, (ballx)
     ld b, a
     ld a, (bally)
     ld c, a
     dec c
     inc b
     CALL Point_on
     ld a, (ballx)
     ld b, a
     ld a, (bally)
     ld c, a
     dec c
     CALL Point_on
     ld a, (balldiry)
     cp $01
     jr z, down
     cp $02
     jr z, up
up:
     ld a, (bally)
     cp $3D
     jp z, changedown
     ld (oldbally), a
     inc a
     ld (bally), a
     ld a, (balldirx)
     cp $01
     jr z, right1
     cp $02
     jr z, left1
down:
     ld a, (bally)
     cp $04
     jr z, changeup
     ld (oldbally), a
     dec a
     ld (bally), a
     ld a, (balldirx)
     cp $01
     jr z, right1
     cp $02
     jr z, left1
right1:
     ld a, (ballx)
     cp $5D
     jp z, changeleft
     ld (oldballx), a
     inc a
     ld (ballx), a
     jp return
left1:
     ld a, (ballx)
     cp $01
     jp z, changeright
     ld (oldballx), a
     dec a
     ld (ballx), a
     jp return
changeup:
     ld a, $00
     ld e, a
     ld a, (ballx)
     ld d, a
     ld a, (PADDLE)
     dec a
     dec a
     dec a
     dec a
checkloop:
     cp d
     jr z, next
     inc a
     push af
     inc e
     ld a, e
     cp $14
     jr z, pop
     pop af
     jr checkloop
pop:
     pop af
     ld hl, $0000
     ld ($800C), hl
     ld hl, youdied
     ROM_CALL(D_ZT_STR)
     ld b, $FF
slowdown:
     halt
     djnz slowdown
     ld hl, $0000
     ld ($800C), hl
     ld hl, spaces
     ROM_CALL(D_ZT_STR)
next:
     ld a, (bally)
     ld (oldbally), a
     dec a
     ld (bally), a
     ld a, $02
     ld (balldiry), a
     ld a, (balldirx)
     cp $01
     jp z, right1
     cp $02
     jr z, left1
changedown:
     ld a, (bally)
     ld (oldbally), a
     inc a
     ld (bally), a
     ld a, $01
     ld (balldiry), a
     ld a, (balldirx)
     cp $01
     jp z, right1
     cp $02
     jp z, left1
changeleft:
     ld a, (ballx)
     ld (oldballx), a
     inc a
     ld (ballx), a
     ld a, $02
     ld (balldirx), a
     jr return
changeright:
     ld a, (ballx)
     ld (oldballx), a
     dec a
     ld (ballx), a
     ld a, $01
     ld (balldirx), a
     jr return
return:
     ret
quit:
 halt
 ret
youdied:
 .db "   You  Died!   ",0
spaces:
 .db "                ",0
#INCLUDE "GRAPH.INC"
.END
